/* Tabela SEQNUMELOCA: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SEQNUMELOCA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SEQNUMELOCA utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_SEQNUMELOCA
AFTER DELETE OR INSERT OR UPDATE
ON SEQNUMELOCA FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;

  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);

BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN

      IF :OLD.CDCTRLNUMENF IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDCTRLNUMENF;
      END IF;

      IF :OLD.CDLOCALEMIS IS NOT NULL THEN
         V_DESC := V_DESC || ' LocalEmis=' || :OLD.CDLOCALEMIS;
      END IF;

      IF :OLD.CDCTRLNUMENF IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDCTRLNUMENF;
      END IF;

      IF :OLD.NRNFINICIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' NrNfInicial=' || :OLD.NRNFINICIAL;
      END IF;

      IF :OLD.NRNFFINAL IS NOT NULL THEN
         V_DESC := V_DESC || 'NrNfFinal=' || :OLD.NRNFFINAL;
      END IF;

      IF :OLD.DTLIBEFAIXNF IS NOT NULL THEN
         V_DESC := V_DESC || ' DtLiberaFaixa=' || :OLD.DTLIBEFAIXNF;
      END IF;

      IF :OLD.NRCDFRINI IS NOT NULL THEN
         V_DESC := V_DESC || 'NrCdFrIni=' || :OLD.NRCDFRINI;
      END IF;

      IF :OLD.NRCDFRFIM IS NOT NULL THEN
         V_DESC := V_DESC || ' NrCdFrFim=' || :OLD.NRCDFRFIM;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDCTRLNUMENF||:OLD.CDLOCALEMIS||:OLD.NRNFINICIAL;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDCTRLNUMENF <> :NEW.CDCTRLNUMENF)  OR
            (:OLD.CDLOCALEMIS  <> :NEW.CDLOCALEMIS)   OR
            (:OLD.NRNFINICIAL  <> :NEW.NRNFINICIAL)   OR
            (:OLD.NRNFFINAL    <> :NEW.NRNFFINAL)     OR
            (NVL(:NEW.DTLIBEFAIXNF, SYSDATE) <> NVL(:OLD.DTLIBEFAIXNF,SYSDATE)) OR
            (NVL(:NEW.NRCDFRINI,'!') <> NVL(:OLD.NRCDFRINI, '!')) OR
            (NVL(:NEW.NRCDFRFIM,'!') <> NVL(:OLD.NRCDFRFIM, '!')) THEN

            IF NVL(:NEW.CDLOCALEMIS,'!') <> NVL(:OLD.CDLOCALEMIS, '!')  THEN
               V_DESC := V_DESC || ' LocalEmis=' || :NEW.CDLOCALEMIS;
            END IF;

            IF NVL(:NEW.CDCTRLNUMENF,'!') <> NVL(:OLD.CDCTRLNUMENF, '!')  THEN
               V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
            END IF;

            IF NVL(:NEW.NRNFINICIAL,'!') <> NVL(:OLD.NRNFINICIAL, '!')  THEN
               V_DESC := V_DESC || ' NrNfInicial=' || :NEW.NRNFINICIAL;
            END IF;

            IF NVL(:NEW.NRNFFINAL,'!') <> NVL(:OLD.NRNFFINAL, '!')  THEN
               V_DESC := V_DESC || 'NrNfFinal=' || :NEW.NRNFFINAL;
            END IF;

            IF NVL(:NEW.DTLIBEFAIXNF, SYSDATE) <> NVL(:OLD.DTLIBEFAIXNF,SYSDATE) THEN
               V_DESC := V_DESC || ' DtLiberaFaixa=' || :NEW.DTLIBEFAIXNF;
            END IF;

            IF NVL(:NEW.NRCDFRINI,'!') <> NVL(:OLD.NRCDFRINI, '!')  THEN
               V_DESC := V_DESC || 'NrCdFrIni=' || :NEW.NRCDFRINI;
            END IF;

            IF NVL(:NEW.NRCDFRFIM,'!') <> NVL(:OLD.NRCDFRFIM, '!')  THEN
               V_DESC := V_DESC || ' NrCdFrFim=' || :NEW.NRCDFRFIM;
            END IF;
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDCTRLNUMENF||:OLD.CDLOCALEMIS||:OLD.NRNFINICIAL;
         END IF;
      ELSE
         IF :NEW.CDCTRLNUMENF IS NOT NULL THEN
            V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
         END IF;

         IF :NEW.CDLOCALEMIS IS NOT NULL THEN
            V_DESC := V_DESC || ' LocalEmis=' || :NEW.CDLOCALEMIS;
         END IF;

         IF :NEW.CDCTRLNUMENF IS NOT NULL THEN
            V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
         END IF;

         IF :NEW.NRNFINICIAL IS NOT NULL THEN
            V_DESC := V_DESC || ' NrNfInicial=' || :NEW.NRNFINICIAL;
         END IF;

         IF :NEW.NRNFFINAL IS NOT NULL THEN
            V_DESC := V_DESC || 'NrNfFinal=' || :NEW.NRNFFINAL;
         END IF;

         IF :NEW.DTLIBEFAIXNF IS NOT NULL THEN
            V_DESC := V_DESC || ' DtLiberaFaixa=' || :NEW.DTLIBEFAIXNF;
         END IF;

         IF :NEW.NRCDFRINI IS NOT NULL THEN
            V_DESC := V_DESC || 'NrCdFrIni=' || :NEW.NRCDFRINI;
         END IF;

         IF :NEW.NRCDFRFIM IS NOT NULL THEN
            V_DESC := V_DESC || ' NrCdFrFim=' || :NEW.NRCDFRFIM;
         END IF;
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDCTRLNUMENF||:NEW.CDLOCALEMIS||:NEW.NRNFINICIAL;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('SEQNUMELOCA',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_SEQNUMELOCA','4.09.063'); END;
/

